Importer.loadQtBinding("qt.core");                                                        
Importer.loadQtBinding("qt.gui");                                                         
Importer.loadQtBinding("qt.uitools");
Importer.loadQtBinding( "qt.network" );
Importer.loadQtBinding( "qt.xml" );




function discogs()
{

	if (Amarok.Playlist.selectedFilenames().length>0)
	{	
		Widget = new QWidget ( this );
		var layout = new QFormLayout(Widget);
		var btn_search = new QPushButton( "Search" , Widget );
		btn_search.autoExclusive=true;
		btn_search.clicked.connect( do_search );
		var btn_cancel = new QPushButton ( "Cancel" , Widget );
		btn_cancel.clicked.connect( Widget.close );
		PlaylistItems = Amarok.Playlist.selectedFilenames();	
		var folder=PlaylistItems[0].split("/")[(PlaylistItems[0].split("/").length - 2)];
		query = new QLineEdit(folder, Widget);
		query.returnPressed.connect( do_search );
		layout.addRow(query);
		layout.addRow(btn_search);
		layout.addRow(btn_cancel);
		Widget.setLayout(layout);
		Widget.setWindowTitle("Discogs :: Look for a release");
		Widget.windowIcon=dg_icon;	
		Widget.show();
		Widget.size=new QSize(res.width/2,Widget.height);
		Widget.move(res.width/4,(res.height-Widget.height)/2);		
		query.setFocus();
	}
	else
	{
		Amarok.alert("Select tracks first");
	}
}

function do_search()
{
	var durl = new QUrl( "http://www.discogs.com/search" );
	durl.addQueryItem( "type" , "releases" );
	durl.addQueryItem( "q" , query.text );
	durl.addQueryItem( "f" , "xml" );
	durl.addQueryItem( "api_key" , "56e41e6406" );
	new Downloader( durl , onFinished );
}

function go_back()
{
	Qresults.close();
	Widget.show();
}

function go_back2()
{
	Qinfo.close();
	Qresults.show();
}

function get_album()
{
	var id_release=discdom.elementsByTagName( "uri" ).at(list_results.currentRow).toElement().text().split("/");
	id_release=id_release[id_release.length-1];
	var durl = new QUrl ( "http://www.discogs.com/release/"+id_release );
	durl.addQueryItem( "f" , "xml" );
	durl.addQueryItem( "api_key" , "56e41e6406" );
	new Downloader( durl , display_info );
}

function write_info()
{
	var pbar = new QProgressBar (this);	
	pbar.setMinimum(1);
	pbar.setWindowTitle("Discogs :: Writing Tags");
	pbar.windowIcon=dg_icon;
	pbar.minimumWidth=Qinfo.width-40;
	pbar.show();
	pbar.move(Qinfo.x+20, (Qinfo.y+Qinfo.height/2-pbar.height/2));
	if (covstate!=2)
	{	
		pbar.setMaximum((chck_4.checked)?(nb_max+1):nb_max);
		for(i=0;i<nb_max;i++)
		{
			Amarok.Playlist.trackAt(array_index[i]).artist=liste.item(i,2).text();
			Amarok.Playlist.trackAt(array_index[i]).album=gl_title;
			Amarok.Playlist.trackAt(array_index[i]).year=gl_year;
			Amarok.Playlist.trackAt(array_index[i]).title=liste.item(i,1).text();		
		
			if ( liste.item(i,0).text().match("-") )
			{
				var nb=new Array;			
				nb=liste.item(i,0).text().split("-");
				Amarok.Playlist.trackAt(array_index[i]).trackNumber=nb[1];
				Amarok.Playlist.trackAt(array_index[i]).discNumber=nb[0];
			}
			else
			{
				Amarok.Playlist.trackAt(array_index[i]).trackNumber=liste.item(i,0).text();
			}
		
			Amarok.Playlist.trackAt(array_index[i]).genre=list_styles.currentText;
			if (chck_3.checked)
			{
				Amarok.Playlist.trackAt(array_index[i]).comment=liste.item(i,3).text();
			}		
			pbar.setValue(i+2)
		}
	}
	else
	{
		pbar.setMaximum(2);
	}
	
	if (chck_4.checked)
	{
		if (file.exists()) file.remove();		
		pix.save(cover_dest.text);
		for(i=0;i<nb_max;i++)
		{
			Amarok.Playlist.trackAt(array_index[i]).imageUrl=cover_dest.text;
		}
		pbar.value++;
	}
		
	pbar.close();
	Qresults.close();	
	Qinfo.close();
	
}


function change_pic(i)
{
	cover_url=new QUrl(discdom2.elementsByTagName("image").at(i).toElement().attribute("uri"));	
	new DataDownloader(cover_url,set_pic);
}
function set_pic(dat)
{
	pix.loadFromData(dat);
	cover_label.setPixmap(pix.scaled(250,250,1,1));
}


function fetch_cover(dat)
{
	pix=new QPixmap;	
	pix.loadFromData(dat);
	cover_label.setPixmap(pix.scaled(250,250,1,1));
	info_lay.addWidget(cover_label,0,0,15,6);	
	
	if (discdom2.elementsByTagName("image").length()>1)
	{
		pix_slider=new QSlider(Qt.Horizontal,Qinfo);
		pix_slider.maximumWidth=250;
		pix_slider.maximum=discdom2.elementsByTagName("image").length()-1;
		pix_slider.valueChanged.connect(change_pic);
        cover_label.setBuddy(pix_slider);
		info_lay.addWidget(pix_slider,15,0,1,3);
	}
	Qinfo.setLayout(layout);			
	
}


function extra_artist(state)
{
	if (state)
	{
		for (i=0; i<nb_max;i++)
		{
            if (chck_5.checked)
            {
               liste.item(i,2).setText(featuring[i].replace(/\ Feat\.\ /,""));
            }
            else
            {        	   
                if(featuring[i]) liste.item(i,2).setText(liste.item(i,2).text()+featuring[i]);
            }
		}	
	}
	else
	{
		for (i=0; i<nb_max;i++)
		{
			if (chck_5.checked)
			{
				liste.item(i,2).setText(gl_artist);
			}
			else
			{
				if(featuring[i]) liste.item(i,2).setText(liste.item(i,2).text().replace(/\ Feat\.\ .*/,""));
			}
		}
	}
	liste.resizeColumnsToContents();	
	
}

function extra_title(state)
{
	if (state)
	{
		for (i=0; i<nb_max;i++)
		{
			if(featuring[i]) liste.item(i,1).setText(liste.item(i,1).text()+featuring[i]);
		}	
	}
	else
	{
		for (i=0; i<nb_max;i++)
		{
			if(featuring[i]) liste.item(i,1).setText(liste.item(i,1).text().replace(/\ Feat\.\ .*/,""));
		}
	}
	liste.resizeColumnsToContents();	
}

function swap_up()
{
	var ind=liste.currentRow();
	if (ind>0)
	{
		var tmp=array_index[ind];
		array_index[ind]=array_index[ind-1];
		array_index[ind-1]=tmp;
		var tmp2=liste.item(ind,4).text();
		var tmp3=liste.item((ind-1),4).text();
		liste.item(ind,4).setText(tmp3);
		liste.item((ind-1),4).setText(tmp2);
		liste.selectRow(ind-1);
	}
	else Amarok.alert("Select a valid row first");
}

function swap_down()
{
	var ind=liste.currentRow();
	if (ind<(nb_max-1))
	{
		var tmp=array_index[ind];
		array_index[ind]=array_index[ind+1];
		array_index[ind+1]=tmp;
		var tmp2=liste.item(ind,4).text();
		var tmp3=liste.item((ind+1),4).text();
		liste.item(ind,4).setText(tmp3);
		liste.item((ind+1),4).setText(tmp2);
		liste.selectRow(ind+1);
	}
	else Amarok.alert("Select a valid row first");
}

function display_info(dat)
{
	discdom2 = new QDomDocument;
	discdom2.setContent( dat );
	nb_max=0;	
	for (z=0 ; z<discdom2.elementsByTagName( "track" ).length() ; z++)
	{
		if ( discdom2.elementsByTagName("track").at(z).firstChildElement( "position").text() ) nb_max++;
	}		
	gl_artist=discdom2.elementsByTagName("name").at(0).toElement().text().replace(/\ \([0-9]+\)/mig , "" );
    gl_artist=gl_artist.replace(/^Various$/ , "Various Artists");	
    gl_title=discdom2.elementsByTagName("title").at(0).toElement().text();
	gl_year=discdom2.elementsByTagName("released").at(0).toElement().text().substring(0,4);
	title= "<b>Artist : " + gl_artist + "<br>Album : " + gl_title + "</b><br><i>Year : " + gl_year + "</i>" ;	
	
	Qinfo = new QWidget (this);
    grp_info=new QGroupBox (Qinfo);	

	list_styles=new QComboBox(grp_info);
	for (i=0; i<discdom2.elementsByTagName("style").count();i++)
	{
		list_styles.addItem(discdom2.elementsByTagName( "style" ).at(i).toElement().text());
	}
	for (i=0; i<discdom2.elementsByTagName("genre").count();i++)
	{
		list_styles.addItem(discdom2.elementsByTagName( "genre" ).at(i).toElement().text());
	}

    
	label=new QLabel(title,grp_info);
	labelb=new QLabel("&Style : ",grp_info);
	list_styles.editable=true;
	labelb.setBuddy(list_styles);

	info_lay=new QGridLayout(grp_info);
	info_lay.addWidget(label,5,6,2,6);
	info_lay.addWidget(labelb,7,6,1,1);
	info_lay.addWidget(list_styles,7,7,1,1);
	grp_info.setLayout(info_lay);
	


	h_piste=new QTableWidgetItem("#");
	h_titre=new QTableWidgetItem("Track");
	h_chemin=new QTableWidgetItem("File");
	h_comm=new QTableWidgetItem("Comments");
	h_artiste=new QTableWidgetItem("Artist");
	
	liste = new QTableWidget (nb_max,5,Qinfo);	
	liste.setHorizontalHeaderItem(0,h_piste);
	liste.setHorizontalHeaderItem(1,h_titre);
	liste.setHorizontalHeaderItem(2,h_artiste);
	liste.setHorizontalHeaderItem(3,h_comm);
	liste.setHorizontalHeaderItem(4,h_chemin);	
	liste.verticalHeader().hide();
	
	liste.selectionBehavior=1;	
	liste.dragEnabled=true;
	liste.acceptDrops=true;
	
	liste.alternatingRowColors=true;
	liste.frameShadow=0x0030;
	liste.frameShape=0x0006;
	
	featuring=new Array;
	var corr=0;	
	for (i=0; i< (nb_max); i++)
	{
		var role="";
		var comments="";		
		var ar_feat=new Array;
		if (!discdom2.elementsByTagName( "track" ).at((i+corr)).firstChildElement( "position").text()) corr++;		
		for (j=0; j< (discdom2.elementsByTagName( "track" ).at(i+corr).toElement().elementsByTagName( "artist" ).count());j++)
		{
			var role = discdom2.elementsByTagName( "track" ).at(i+corr).toElement().elementsByTagName( "artist" ).at(j).firstChildElement("role").text();
			var extra = discdom2.elementsByTagName( "track" ).at(i+corr).toElement().elementsByTagName( "artist" ).at(j).firstChildElement("name").text().replace(/\ \([0-9]+\)/mig , "" );
			

			if (role.match("Featuring") || (!role) )
			{
				ar_feat.push(extra);
			}
			else
			{
				comments+=role+" : "+extra+" \n";
			}
		}
	
		
		for (k=0;k<ar_feat.length;k++)
		{
			if (k==0)
			{
				featuring[i]=" Feat. "+ar_feat[k];
			}
			else if ((k+1)==ar_feat.length)
			{
				featuring[i]+=" & "+ar_feat[k];
			}
			else
			{
				featuring[i]+=", "+ar_feat[k];
			}
		}

		entry = new QTableWidgetItem(discdom2.elementsByTagName( "track" ).at(i+corr).firstChildElement( "position").text());
		liste.setItem(i,0,entry);
 
		if (featuring[i])
		{		
			var entry = new QTableWidgetItem(discdom2.elementsByTagName( "track" ).at(i+corr).firstChildElement( "title").text()+featuring[i]);
			liste.setItem(i,1,entry);
		}
		else
		{
			var entry = new QTableWidgetItem(discdom2.elementsByTagName( "track" ).at(i+corr).firstChildElement( "title").text());
			liste.setItem(i,1,entry);
		}
		
		entry = new QTableWidgetItem(comments);
		liste.setItem(i,3,entry);
		entry = new QTableWidgetItem(gl_artist);
		liste.setItem(i,2,entry);
	}
	
	if (PlaylistItems.length<nb_max)
	{
		nb_max=PlaylistItems.length;
	}
	for (i=0; i<nb_max;i++)
	{
		var entry = new QTableWidgetItem( PlaylistItems[i].split("/")[PlaylistItems[i].split("/").length-1]);
		liste.setItem(i,4,entry);
	}

		
	liste.resizeColumnsToContents();	
	var height=((liste.rowHeight(0)*(liste.rowCount+1))>=768)?700:liste.rowHeight(0)*(liste.rowCount+1);
	var width=liste.columnWidth(0)+liste.columnWidth(1)+liste.columnWidth(2)+liste.columnWidth(3)+liste.columnWidth(4)
	var size=new QSize(width,height);
	liste.size=size;


	grp_chck=new QGroupBox ("Options", Qinfo );
	chck_1=new QCheckBox ("Add Extra Artists To Title Field", grp_chck);
	chck_2=new QCheckBox("Add Extra Artists To Artist Field", grp_chck);
	chck_3=new QCheckBox("Write Comments", grp_chck);
	chck_5=new QCheckBox("Compilation Mode", grp_chck);
	chck_1.clicked.connect(extra_title);	
	chck_2.clicked.connect(extra_artist);
	chck_1.checked=true;	
	chck_3.checked=true;
    
    
	box_lay=new QGridLayout(grp_chck);
	box_lay.addWidget(chck_1,1,0,1,1);
	box_lay.addWidget(chck_2,2,0,1,1);
	box_lay.addWidget(chck_3,1,1,1,1);
	box_lay.addWidget(chck_5,1,2,1,1);

	grp_chck.setLayout(box_lay);
	btn_ok = new QPushButton ( "OK" , Qinfo );
	btn_ok.clicked.connect(write_info);
	btn_return = new QPushButton ( "Back" , Qinfo );
	btn_return.clicked.connect(go_back2);
	btn_up = new QPushButton ( "Move Up" , Qinfo );
	btn_up.clicked.connect(swap_up);
	btn_down = new QPushButton ( "Move Down" , Qinfo );
	btn_down.clicked.connect(swap_down);
	

	layout = new QGridLayout (Qinfo);
	layout.addWidget(grp_info,0,0,1,7);
	layout.addWidget(liste,3,0,6,6);
	layout.addWidget(btn_up,3,6,1,1);
	layout.addWidget(grp_chck,9,0,1,7);
	layout.addWidget(btn_return,10,0,1,1);
	layout.addWidget(btn_ok,10,6,1,1);	
	layout.addWidget(btn_down,4,6,1,1);	
	Qresults.hide();
	Qinfo.move(Qresults.x,Qresults.y);
	Qinfo.size=Qresults.size;	
	Qinfo.setWindowTitle("Discogs :: "+gl_artist+" - "+gl_title+" - "+gl_year);
	Qinfo.windowIcon=dg_icon;	
	cover_index=0;

	if ( discdom2.elementsByTagName("image").at(cover_index).toElement().attribute("uri") )
	{
		covstate=0;		
		cover_label=new QLabel(grp_info);
		chck_4=new QCheckBox("Save Cover", grp_chck);
		chck_4.tristate=true;
		box_lay.addWidget(chck_4,2,1,1,1);				
		path=Amarok.Playlist.trackAt(Amarok.Playlist.selectedIndexes()[0]).path.split("/");
		path.pop();
		path=path.join("/")+"/cover.jpg";		
		cover_dest=new QLineEdit(grp_chck);
		cover_dest.visible=false;
		cover_dest.textChanged.connect(check_file);		
		box_lay.addWidget(cover_dest,2,2,1,1);		
		chck_4.clicked.connect(cover_check);
		cover_url=new QUrl(discdom2.elementsByTagName("image").at(0).toElement().attribute("uri") );	
		new DataDownloader(cover_url, fetch_cover);
	}
	else
	{
		Qinfo.setLayout(layout);		
	}
	
	array_index=Amarok.Playlist.selectedIndexes();
	Qinfo.show();
}

function check_file(fn)
{
	file=new QFile(fn);
	if (file.exists()) Amarok.alert(fn+" already exists and will be overwritten.","sorry");
}

function cover_check(state) 
{
		cover_dest.maximumWidth=chck_5.width;		
		cover_dest.visible=state;
		if (state) 
		{
			cover_dest.setText(path);
		}
		covstate=(covstate+1)%3	
		switch (covstate)
		{
			case 0: chck_4.text="Save cover";
				disable_all(false);
				break;
			case 1: chck_4.text="Save cover to"; 
				break;
			case 2:	chck_4.text="Save Cover ONLY";
				disable_all(true);
			break;
		}

}

function disable_all(b)
{
	liste.setEnabled(!b);
	list_styles.setEnabled(!b);
	chck_1.setEnabled(!b);
	chck_2.setEnabled(!b);
	chck_3.setEnabled(!b);
	chck_5.setEnabled(!b);
	btn_up.setEnabled(!b);
	btn_down.setEnabled(!b);
}
	
function changedesc(i)
{
	var text="<br><b>"+discdom.elementsByTagName( "summary" ).at(i).toElement().text()+"</b><br>";
	description.setText(text);
	btn_ok.enabled=true;
	description.adjustSize();
}


function onFinished(dat)
{

	Qresults = new QWidget (this);
	var layout = new QGridLayout(Qresults);	
	btn_ok = new QPushButton( "OK" , Qresults );
	btn_ok.enabled=false;
	btn_ok.clicked.connect( get_album );
	var btn_return = new QPushButton( "Back" , Qresults );
	btn_return.clicked.connect( go_back );
	discdom = new QDomDocument;
	discdom.setContent( dat );
	
	
	description=new QLabel(Qresults);
	nb_results=Math.min(discdom.elementsByTagName( "searchresults" ).at(0).toElement().attribute("end",discdom.elementsByTagName( "searchresults" ).at(0).toElement().attribute("numResults")));
	list_results=new QListWidget(Qresults);
	icon_vinyl=new QIcon(Amarok.Info.scriptPath() + "/vinyl.png");
	icon_cd=new QIcon(Amarok.Info.scriptPath() + "/cd.png");
	for (i=0;i<nb_results;i++)
	{
		list_results.addItem(discdom.elementsByTagName( "title" ).at(i).toElement().text().replace("\n",""));
		var vin=/\ vinyl\ /i;
		var cd=/\ cd\ /i;		
		if (vin.test(discdom.elementsByTagName( "summary" ).at(i).toElement().text()))
		{
			list_results.item(i).setIcon(icon_vinyl);
		}
		else if(cd.test(discdom.elementsByTagName( "summary" ).at(i).toElement().text()))
		{
			list_results.item(i).setIcon(icon_cd);
		}
	}
	list_results.currentRowChanged.connect(changedesc);
	description.textFormat=Qt.RichText;
	description.wordWrap=true;
	layout.addWidget(list_results,0,0,2,2);
	layout.addWidget(description,2,0,2,2);	
	layout.addWidget(btn_ok,4,1,1,1);
	layout.addWidget(btn_return,4,0,1,1);
	Qresults.setLayout(layout);
	Widget.close();
	Qresults.size=new QSize(res.width/2,res.height/2);	
	Qresults.move(Widget.x,res.height/4);
	Qresults.setWindowTitle("Discogs :: Search Results");	
	Qresults.windowIcon=dg_icon;
	Qresults.show();
}

res=new QDesktopWidget();
dg_icon=new QIcon(Amarok.Info.scriptPath() + "/icon.png");
Amarok.Window.addToolsSeparator();
Amarok.Window.addToolsMenu( "Discogs", "Retrieve Tags on Discogs" , Amarok.Info.scriptPath() + "/icon.png");
Amarok.Window.ToolsMenu.Discogs['triggered()'].connect(discogs);


